//Code by Pika UwU
rawset(_G, "sphud", {})
sphud.speedometer = CV_RegisterVar({"sp_speedometer", "On", CV_NETVAR|CV_MODIFIED, CV_OnOff})

local function IsPlayerValid(player)
	return (player and player.valid) and (player.mo and player.mo.valid)
end

local function SpeedyHUD(v, player)
	local client
	client = player
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "speedy") then
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return
	end

	if (sphud.speedometer.value) then
		local calcspeed, decimal = player.speed / FRACUNIT, FixedMul(player.speed % FRACUNIT, 10*FRACUNIT)/FRACUNIT
		local final = calcspeed + "." + decimal + " FU/t"
		
		v.drawString(16, 164, "Speed: " .. final, skincolors[player.skincolor].chatcolor|V_PERPLAYER|V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
	end
end
hud.add(SpeedyHUD, "game")